#include <sstream>
#include <vector>
#include <cstdio> 
#include <cstdlib> 
#include <random>
#include <math.h>
#include <algorithm>
#include <iostream>
#include <sstream>

using namespace std;
const int seed_manual = 10;
mt19937 rng(seed_manual);
uniform_real_distribution<> coin_flip(0.0, 1.0);

int main() {

	FILE* pFile; FILE* pFile1;

	stringstream nameSum, name1;

	nameSum << "Simulation_generated_production_line_ASF_FDF.csv";
	name1 << "system_states_in_time_ASF_FDF.csv";

	fopen_s(&pFile, nameSum.str().c_str(), "w");

	fopen_s(&pFile1, name1.str().c_str(), "w");

	int nperiods = 10000; // num of t's 

	int ntypes = 6; // num of product types

	int nstations = 11; // s24, 25, 26, 27, 29, 30, 33, 34, 35, 36, 37

	vector<double>arrival_rates(ntypes, 0.0);

	double arr_rate_type_6 = 1.0; // fix it for the last type
	arrival_rates[5] = arr_rate_type_6;
	arrival_rates[4] = (18646.0 / 17923.0) * arrival_rates[5];
	arrival_rates[3] = (20041.0 / 17923.0) * arrival_rates[5];
	arrival_rates[2] = (20830.0 / 17923.0) * arrival_rates[5];
	arrival_rates[1] = (50213.0 / 17923.0) * arrival_rates[5];
	arrival_rates[0] = (51709.0 / 17923.0) * arrival_rates[5];

	vector<vector<int>>type_paths; // per type show 0/1 per station 
	for (int i = 0; i < ntypes; i++) {
		vector<int>s(nstations, 0);
		type_paths.push_back(s);

	}

	for (int i = 0; i < ntypes; i++) {
		type_paths[i][4] = 1; //s29
		type_paths[i][5] = 1; //s30
		type_paths[i][6] = 1; //s33
		type_paths[i][7] = 1; //s34

		type_paths[i][10] = 1; // s37 

		if (i == 0 || i == 2 || i == 4) {
			type_paths[i][9] = 1; //s36
		}
		else {
			type_paths[i][8] = 1; //s35
		}

		if (i != 2 && i != 3) {
			type_paths[i][0] = 1; // s24 
		}
		else {
			type_paths[i][1] = 1; // s25
		}
		if (i != 5 && i != 6) {
			type_paths[i][2] = 1; // s26
		}
		else {
			type_paths[i][3] = 1; // s27
		}

	}

	vector<double>processing_rates(nstations, 0.0);

	// ramdomize procesessing rates
	uniform_real_distribution<> proc_fast(18.0, 18.0);
	uniform_real_distribution<> proc_slow(12.0, 12.0);
	


	vector<double>prob_to_active(nstations, 0.3); // repair probs
	vector<double>prob_to_inactive_normal(nstations, 0.05); // failure probs from healthy state
	vector<double>prob_to_inactive_higher(nstations, 0.1); // failure probs from degraded. state

	double prob_system_failure = 0.01;
	int workload_limit_summer = 100; // during summer 
	int workload_limit_outside_summer = 150; // during summer 
	int system_failed_limit = 35; // if system fails at period t, do not allow for the upcoming .. periods for another system failure, protected mode ! 

	vector<int>degradation_thresholds(nstations, 100); // after 100 periods it wears outs 

	// degred. toler.

	int degred_tol_high = 70; // two weeks 
	int degred_tol_low = 20; 

	vector<int>faster_stations(nstations, 0);

	
	for (int i = 0; i < nstations; i++) {
		
		if (i >=0) {
			faster_stations[i] = 1; 
			degradation_thresholds[i] = degred_tol_low;
		}
		else {
			degradation_thresholds[i] = degred_tol_low;
		}
	}

	///////////////////////////////////////////////// TRACK INFO 

	// health states of stations 0,1,2 0 inactive, 2 active new, 1 is active but degraded 
	vector<int>machine_health_states(nstations, 2);

	vector<int>machine_active_forhowlong(nstations, 0);

	vector<vector<int>>queues; // job ids at each station

	vector<int>r;
	for (int i = 0; i < nstations; i++)
		queues.push_back(r);



	int look_short = 5;
	int look_long = 20;

	vector<int>system_throughput_short(look_short, 0);
	vector<int>system_throughput_long(look_long, 0);

	vector<double>system_leadtime_short(look_short, 0.0);
	vector<double>system_leadtime_long(look_long, 0.0);

	vector<vector<int>>types_throughput_short;
	vector<vector<int>>types_throughput_long;

	vector<vector<double>>types_leadtime_short;
	vector<vector<double>>types_leadtime_long;

	vector<int>r1(look_short, 0);
	vector<int>r2(look_long, 0);

	vector<double>r3(look_short, 0.0);
	vector<double>r4(look_long, 0.0);


	for (int i = 0; i < ntypes; i++) {
		types_leadtime_short.push_back(r3);
		types_leadtime_long.push_back(r4);
		types_throughput_short.push_back(r1);
		types_throughput_long.push_back(r2);
	}




	vector<vector<double>>data_to_write_jobs_inside; // state info taken at the arrival moment 

	// FEATURES - JOBID X1, TYPE X1, QUEUE LENGTHS AT STATIONS X11, QSUM, QSUM_ROUTE, NUM_NON_DEGRED_MACHINES_ROUTE, NUM_DEGRED_MACHINES_ROUTE, NUM_FAILED_MACHINES_ROUTE, MACHINE HEALTH STATES X11, MACHINE OPERATIONAL TIME X 11, STS X1, STL X1, SLTS 1X, SLTL 1X, TYPES TS X1 (OWN TYPE), TYPES TL X1, TYPES LTS 1X, TYPES LTL 1X

	int nfeatures = 1 + 1 + 11 + 1 + 1 + 1+ 1+ 1+ 11 + 11 + 12 + 12 + 1; // last one is for leadtime 


	int jobid = 0;

	int week_day = 1;

	int which_week_period = 0;

	int which_weeked_period = -1;

	int since_system_failure = system_failed_limit+1; 

	for (int t = 0; t < nperiods; t++) {

		int summer = 0;
		if ((t % (35 * 52)) >= 0 && (t % (35 * 52)) <= 35 * 13) {
			summer = 1;
			//summer period
		}

	

		if (which_week_period < 25 && which_week_period >=0) {
			which_week_period++;
		}
		else if (which_week_period==25) {
			which_week_period = -1;
			
			which_weeked_period = 0;
		}
		else if (which_week_period == -1) {
			if (which_weeked_period < 10) {
				which_weeked_period++;
				week_day = 0; 
			}
			else{
				week_day = 1;
				which_weeked_period = -1;
				which_week_period = 0;
			}
			
			
		}


		cout << "period " << t <<endl;
		

	
		// check machine states, breakdowns and repairs 

		// check also system failure probability -NOISE 
		int works = 0; // Q 
		
		double system_breakdown = 1.0; // not activated 
		for (int i = 0; i < nstations; i++) {			
			works += int(queues[i].size());
			
		}
		
		
		// station dependency through total workload tolerance, 
		if ((works > workload_limit_summer && summer==1) || (works> workload_limit_outside_summer)) {
			system_breakdown = coin_flip(rng);
		}
	

		if (system_breakdown <= prob_system_failure){
			
			if (since_system_failure > system_failed_limit) {
				cout << "system failure at " << t << endl;
				since_system_failure = 0;
			}
			else {
				system_breakdown = 1.0;
				since_system_failure++;
			}

		}
		else {
			since_system_failure++;
		}

		int swb = 0;
		if (system_breakdown <= prob_system_failure) swb = 1;

		for (int i = 0; i < nstations; i++) {

			if (machine_health_states[i] == 2) {// good as new state
				double breakdown = coin_flip(rng);
				if (breakdown <= prob_to_inactive_normal[i] || system_breakdown<=prob_system_failure) {
					machine_health_states[i] = 0;
					machine_active_forhowlong[i] = 0;
				}
				else {
					machine_active_forhowlong[i]++;
				}
			}
			else if (machine_health_states[i] == 1) { // degraded state 
				double breakdown = coin_flip(rng);
				if (breakdown <= prob_to_inactive_higher[i] || system_breakdown <= prob_system_failure) {
					machine_health_states[i] = 0;
					machine_active_forhowlong[i] = 0;
				}
				else {
					machine_active_forhowlong[i]++;
				}
			}
			else { // was inactive, repaired?
				double repair = coin_flip(rng);
				if (repair <= prob_to_active[i]){
					machine_health_states[i] = 2;
					machine_active_forhowlong[i]++; // from 0 to 1
				}

			}
		}

		

		int sumq = 0;
		for (int i = 0; i < nstations; i++) {

			fprintf(pFile1, "%d,", (int)queues[i].size());
			sumq += (int)queues[i].size();
		}
		fprintf(pFile1, "%d, %d", sumq, swb);
		fprintf(pFile1, "\n");

		// arrival events occur 
		for (int j = 0; j < ntypes; j++) {

			
			poisson_distribution<int> arr_dist(arrival_rates[j]);

			int narrivals = arr_dist(rng);
			if (week_day == 0) {//weekends 
				narrivals = narrivals*2;
			}
			else {
				narrivals = narrivals/2;
			}

			for (int k = 0; k < narrivals; k++) {
				// add them to the queue of their first station

				for (int i = 0; i < nstations; i++) {
					if (type_paths[j][i] == 1) { // find the first station 
						queues[i].push_back(jobid);
						break;
					}
				}

				// capture state info for data 
				vector<double>data_job(nfeatures, 0.0);
				int index_write = 0;

				data_job[index_write] = jobid;
				index_write++;
				data_job[index_write] = (j + 1); // type info
				index_write++;
				double sum_along_route = 0.0;
				double sum_all = 0.0;


				// along the route cumulative machine health states 
				double num_degraded_route = 0.0;
				double num_healthy_route = 0.0;
				double num_failed_route = 0.0;

				// queue lengths 
				for (int i = 0; i < nstations; i++) {
					data_job[index_write] = queues[i].size();
					sum_all += queues[i].size();
					index_write++;
					if (type_paths[j][i] == 1) {
						sum_along_route += queues[i].size();
						if (machine_health_states[i] == 2) {
							num_healthy_route++;
						}
						else if (machine_health_states[i] == 1) {
							num_degraded_route++;
						}
						else {
							num_failed_route++;
						}
					}
				}

				data_job[index_write] = double(sum_along_route);
				index_write++;
				data_job[index_write] = double(sum_all);
				index_write++;
				data_job[index_write] = double(num_healthy_route);
				index_write++;
				data_job[index_write] = double(num_degraded_route);
				index_write++;
				data_job[index_write] = double(num_failed_route);
				index_write++;

				// system perf. measures

				vector<double>data_perf;

				for (int i = 0; i < nstations; i++) {
					data_perf.push_back(machine_active_forhowlong[i]);
					data_perf.push_back(machine_health_states[i]);
				}


				double min_ts = *min_element(system_throughput_short.begin(), system_throughput_short.end());
				data_perf.push_back(min_ts);

				double min_tl = *min_element(system_throughput_long.begin(), system_throughput_long.end());

				data_perf.push_back(min_tl);

				double min_lts = *min_element(system_leadtime_short.begin(), system_leadtime_short.end());
				data_perf.push_back(min_lts);

				double min_ltl = *min_element(system_leadtime_long.begin(), system_leadtime_long.end());
				data_perf.push_back(min_ltl);

				double max_ts = *max_element(system_throughput_short.begin(), system_throughput_short.end());
				data_perf.push_back(max_ts);

				double max_tl = *max_element(system_throughput_long.begin(), system_throughput_long.end());
				data_perf.push_back(max_tl);

				double max_lts = *max_element(system_leadtime_short.begin(), system_leadtime_short.end());
				data_perf.push_back(max_lts);

				double max_ltl = *max_element(system_leadtime_long.begin(), system_leadtime_long.end());
				data_perf.push_back(max_ltl);

				// type specific perf. measures 



				double min_tts = *min_element(types_throughput_short[j].begin(), types_throughput_short[j].end());
				data_perf.push_back(min_tts);

				double min_ttl = *min_element(types_throughput_long[j].begin(), types_throughput_long[j].end());
				data_perf.push_back(min_ttl);

				double min_tlts = *min_element(types_leadtime_short[j].begin(), types_leadtime_short[j].end());
				data_perf.push_back(min_tlts);

				double min_tltl = *min_element(types_leadtime_long[j].begin(), types_leadtime_long[j].end());
				data_perf.push_back(min_tltl);

				double max_tts = *max_element(types_throughput_short[j].begin(), types_throughput_short[j].end());
				data_perf.push_back(max_tts);

				double max_ttl = *max_element(types_throughput_long[j].begin(), types_throughput_long[j].end());
				data_perf.push_back(max_ttl);

				double max_tlts = *max_element(types_leadtime_short[j].begin(), types_leadtime_short[j].end());
				data_perf.push_back(max_tlts);

				double max_tltl = *max_element(types_leadtime_long[j].begin(), types_leadtime_long[j].end());
				data_perf.push_back(max_tltl);

				double ave_ts = 0.0;
				double ave_tl = 0.0;
				double ave_lts = 0.0;
				double ave_ltl = 0.0;

				double ave_tts = 0.0;
				double ave_ttl = 0.0;
				double ave_tlts = 0.0;
				double ave_tltl = 0.0;

				int short_lt_active = 0;
				int long_lt_active = 0;

				int short_lt_system_active = 0;
				int long_lt_system_active = 0;

				for (int i = 0; i < look_short; i++) {
					ave_ts += system_throughput_short[i];

					if (system_leadtime_short[i] >= 0) {
						ave_lts += system_leadtime_short[i];
						short_lt_system_active++;
					}

					ave_tts += types_throughput_short[j][i];

					if (types_leadtime_short[j][i] >= 0) {
						short_lt_active++;
						ave_tlts += types_leadtime_short[j][i];
					}

				}
				for (int i = 0; i < look_long; i++) {
					ave_tl += system_throughput_long[i];

					if (system_leadtime_long[i] >= 0) {
						ave_ltl += system_leadtime_long[i];
						long_lt_system_active++;
					}

					ave_ttl += types_throughput_long[j][i];

					if (types_leadtime_long[j][i] >= 0) {
						long_lt_active++;
						ave_tltl += types_leadtime_long[j][i];
					}

				}
				ave_ts = (double)ave_ts / look_short;
				data_perf.push_back(ave_ts);

				ave_tl = (double)ave_tl / look_long;
				data_perf.push_back(ave_tl);

				ave_lts = (double)ave_lts / short_lt_system_active;
				data_perf.push_back(ave_lts);

				ave_ltl = (double)ave_ltl / long_lt_system_active;
				data_perf.push_back(ave_ltl);

				ave_tts = (double)ave_tts / look_short;
				data_perf.push_back(ave_tts);

				ave_ttl = (double)ave_ttl / look_long;
				data_perf.push_back(ave_ttl);

				ave_tlts = (double)ave_tlts / short_lt_active;
				data_perf.push_back(ave_tlts);

				ave_tltl = (double)ave_tltl / long_lt_active;
				data_perf.push_back(ave_tltl);

				for (int b = 0; b < data_perf.size(); b++) {
					data_job[index_write] = data_perf[b];
					index_write++;
				}

				data_job[index_write] = 0.0; //for lead time 
				index_write++;

				data_to_write_jobs_inside.push_back(data_job);

				jobid++;
			}
		}



		// transitions and completions 
		vector<double>type_leadtime_recent(ntypes, 0.0);

		vector<int>type_throughput_recent(ntypes, 0);

		int total_throughput_recent = 0;
		double total_leadtime_recent = 0.0;

		// number of jobs processed at stations 
		vector<int>departures(nstations, 0);

		int nprocecessed = 0;

		for (int i = 0; i < nstations; i++) {
			if (machine_health_states[i] > 0) { // can process when not failed 
				if (faster_stations[i] == 1)
					processing_rates[i] = proc_fast(rng); // resample every time! 
				else
					processing_rates[i] = proc_slow(rng);

				// every 5th period, last shift of the day slower processing 
				if ((t + 1) % 5 == 0) {
					processing_rates[i] = processing_rates[i] / 2.0;
				}

				poisson_distribution<int> proc_dist(processing_rates[i]);
				int nmax = (int)queues[i].size();
				nprocecessed = min(nmax, proc_dist(rng));
			}
			else {
				nprocecessed = 0;
			}
			//cout << nprocecessed << " moved from station " << i << endl;
			
			departures[i] = nprocecessed;
		}

		for (int i = 0; i < nstations; i++) {

			nprocecessed = departures[i];

	


			if (i < nstations - 1) { // not finished yet 
				for (int k = 0; k < nprocecessed; k++) {
					int id = queues[i][0]; // FIFO SERVICE 
					queues[i].erase(queues[i].begin());
					// find the type of the job and update its lead time 
					int type = 1;
					for (int n = 0; n < data_to_write_jobs_inside.size(); n++) {
						if (data_to_write_jobs_inside[n][0] == id) {
							type = data_to_write_jobs_inside[n][1];
							data_to_write_jobs_inside[n][nfeatures - 1] += 1.0; // lead time is the last feature 
							break;
						}
					}
					// to the next station

					for (int n = i + 1; n < nstations; n++) {
						if (type_paths[type - 1][n] == 1) {
							queues[n].push_back(id);
							break;
							
						}
					}

				}
				// FOR THE OTHERS, UPDATE LEADTIMES
				for (int k = 0; k < queues[i].size(); k++) {

					for (int n = 0; n < data_to_write_jobs_inside.size(); n++) {
						if (data_to_write_jobs_inside[n][0] == queues[i][k]) {
							data_to_write_jobs_inside[n][nfeatures - 1] += 1.0; // lead time is the last feature 
							break;
						}
					}
				}

			}

			else { // jobs at the final station 

				for (int k = 0; k < nprocecessed; k++) {
					int id = queues[i][0]; // FIFO SERVICE 
					queues[i].erase(queues[i].begin());
					// find the type of the job and update its lead time 
					int type = 1;
					for (int n = 0; n < data_to_write_jobs_inside.size(); n++) {
						if (data_to_write_jobs_inside[n][0] == id) {
							type = data_to_write_jobs_inside[n][1];
							data_to_write_jobs_inside[n][nfeatures - 1] += 1.0; // lead time is the last feature 

							// pick up stage, random time NOISE FEATURE - UNPREDICTABLE LEAD TIME FACTOR 

							uniform_int_distribution<>pickup(0.0, 2.0);
							data_to_write_jobs_inside[n][nfeatures - 1] += pickup(rng); 


							// now we are ready to write the data since we know the lead time of the product 
							for (int n1 = 0; n1 < data_to_write_jobs_inside[n].size(); n1++) {
								if (data_to_write_jobs_inside[n][n1] >= 0.0)
									fprintf(pFile, "%f,", data_to_write_jobs_inside[n][n1]);
								else
									fprintf(pFile, "-1,");
							}
							fprintf(pFile, "\n");
							// now we can delete this row 
							data_to_write_jobs_inside.erase(data_to_write_jobs_inside.begin() + n);


							// perf. measures for the current time period
							type_leadtime_recent[type - 1] += data_to_write_jobs_inside[n][nfeatures - 1];
							type_throughput_recent[type - 1] += 1;
							total_throughput_recent += 1;
							total_leadtime_recent += data_to_write_jobs_inside[n][nfeatures - 1];
							break;
						}
					}

				}

				// FOR THE OTHERS, UPDATE LEADTIMES
				for (int k = 0; k < queues[i].size(); k++) {

					for (int n = 0; n < data_to_write_jobs_inside.size(); n++) {
						if (data_to_write_jobs_inside[n][0] == queues[i][k]) {
							data_to_write_jobs_inside[n][nfeatures - 1]++; // lead time is the last feature 
							break;
						}
					}
				}

			}


		}


		// update short, long moving average perf. measures 

		//update system overall perf. 
		total_leadtime_recent = total_leadtime_recent / (double)total_throughput_recent;
		for (int j = look_short - 1; j > 0; j--) {

			system_throughput_short[j] = system_throughput_short[j - 1];
			system_leadtime_short[j] = system_throughput_short[j - 1];
		}
		for (int j = look_long - 1; j > 0; j--) {

			system_throughput_long[j] = system_throughput_long[j - 1];
			system_leadtime_long[j] = system_throughput_long[j - 1];
		}
		system_throughput_short[0] = total_throughput_recent;
		system_leadtime_short[0] = total_leadtime_recent;
		system_throughput_long[0] = total_throughput_recent;
		system_leadtime_long[0] = total_leadtime_recent;

		for (int i = 0; i < ntypes; i++) {

			type_leadtime_recent[i] = (double)type_leadtime_recent[i] / type_throughput_recent[i];
			for (int j = look_short - 1; j > 0; j--) {
				types_leadtime_short[i][j] = types_leadtime_short[i][j - 1];
				types_throughput_short[i][j] = types_throughput_short[i][j - 1];
			}
			for (int j = look_long - 1; j > 0; j--) {
				types_leadtime_long[i][j] = types_leadtime_long[i][j - 1];
				types_throughput_long[i][j] = types_throughput_long[i][j - 1];
			}
			//cout << "recent ave lead time  " << type_leadtime_recent[i] << endl;
			types_leadtime_short[i][0] = type_leadtime_recent[i];
			types_throughput_short[i][0] = type_throughput_recent[i];

			types_leadtime_long[i][0] = type_leadtime_recent[i];
			types_throughput_long[i][0] = type_throughput_recent[i];
		}



		// machine degredations 
		for (int i = 0; i < nstations; i++) {
			if (machine_health_states[i] == 2) {// good as new state
				if (machine_active_forhowlong[i] > degradation_thresholds[i]) {
					machine_health_states[i] = 1;
				}
			}
		}





	}


}